<?php
class API {
    private $baseURL;
    private $token;

    public function __construct($baseURL, $token=null) {
        $this->baseURL = $baseURL;
        $this->token = $token;
    }

    public function get($endpoint, $params = array()) {
        $url = $this->baseURL . $endpoint;
        if (!empty($params)) {
            $url .= '?' . http_build_query($params);
        }

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', "AUTHORIZATION: $this->token"));
        
        $response = curl_exec($ch);

        if ($response  === false) {
            echo 'Erro ao fazer a requisição GET: ' . curl_error($ch);
        }

        curl_close($ch);

        return $response;
    }

    public function post($endpoint, $data = array()) {
        $url = $this->baseURL . $endpoint;

        $jsonData = json_encode($data);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', "AUTHORIZATION: $this->token"));

        $response = curl_exec($ch);

        if ($response  === false) {
            echo 'Erro ao fazer a requisição POST: ' . curl_error($ch);
        }

        curl_close($ch);

        return $response;
    }

    public function put($endpoint, $data = array()) {
        $url = $this->baseURL . $endpoint;

        $jsonData = json_encode($data);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');  // Definindo o método PUT
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', "AUTHORIZATION: $this->token"));

        $response = curl_exec($ch);

        if ($response  === false) {
            echo 'Erro ao fazer a requisição PUT: ' . curl_error($ch);
        }

        curl_close($ch);

        return $response;
    }

    public function delete($endpoint) {
        $url = $this->baseURL . $endpoint;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE');  // Definindo o método DELETE
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json', "AUTHORIZATION: $this->token"));

        $response = curl_exec($ch);

        if ($response === false) {
            echo 'Erro ao fazer a requisição DELETE: ' . curl_error($ch);
        }

        curl_close($ch);

        return $response;
    }
}

class SlurmAPI {  
    public function submit($baseURL, $token, $data){

      $api = new API($baseURL, $token);
            
      $result = $api->post('/trabalhos/submissao/paralelo', $data);
      
      return json_decode($result);
    }

    //Somente usado em Utilities updateStates
    public function getJobs($baseURL, $token, $data){
        $api = new API($baseURL, $token);
        $result = $api->get('/trabalhos', $data);
        echo json_encode($data);
        echo $result;

        return json_decode($result);
    }

    public function cancelJobs($baseURL, $token, $data){
      $api = new API($baseURL, $token);
      $api->put('/trabalhos/cancelar', $data);

    }
}
?>