<?php


use \Firebase\JWT\JWT;
use Firebase\JWT\Key;

class Admin{
    protected $ModelUsers;
    protected $ModelJobs;
    protected $ModelCommands;
    protected $ModelClusters;
    protected $ModelProjects;
    protected $ModelQueues;
    protected $ModelImages;
    
    public function __construct() {
		$this->ModelUsers = new ModelUsers('users');
        $this->ModelJobs = new ModelJobs('jobs');
		$this->ModelCommands = new ModelCommands('commands');
		$this->ModelClusters = new ModelClusters('clusters');
		$this->ModelProjects = new ModelProjects('projects');
		$this->ModelQueues = new ModelQueues('queues');
		$this->ModelImages = new ModelImages('images');
    }

    public function beforeRoute($f3){
        try{
            if (isset($_COOKIE['token'])) {
                $token = $_COOKIE['token'];
                $data = JWT::decode($token, new Key($_ENV["TOKEN"], 'HS256'));

                $result = $this->ModelUsers->find($columns=array(), $filters=array('id' => $data->id, 'admin' => 1));
                if($result){
                    $f3->set('user', $result[0]);
                } else {
                    $f3->error( 403, "Acesso não autorizado!");
                }
    
            } else{
                $f3->error( 401, "Acesso não autorizado!");
            }

        } catch (Exception $exception) {
            $f3->error( 401, "Acesso não autorizado: " . $exception->getMessage());
        }
    }

    public function afterroute($f3){
        return;
    }
}
?>