<?php
class ControllerAdminClusters extends Admin{
    public function __construct() {
        parent::__construct();
    }

    public function post($f3) {
		try {
            $data = json_decode(file_get_contents('php://input'), true);
            $name = $data['name'];
            $url = $data['url'];
            $token = $data['token'];

            $cluster = $this->ModelClusters->find($columns=array('id'),$filters=array('name'=>$name));
            if($cluster) $f3->error(423, "O cluster já existe!");

            $this->ModelClusters->insert(
                array('name', 'url', 'token'), 
                array(
                    array(
                        $name,
                        $url,
                        $token
                    )
                )
            );

		} catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

    public function put($f3){
        try {            
            $data = json_decode(file_get_contents('php://input'), true);
            $id = $data['id'];
            $name = $data['name'];
            $url = $data['url'];
            $token = $data['token'];
            

            $cluster = $this->ModelClusters->find($columns=array('id'),$filters=array('name'=>$name));
            if($cluster && $cluster[0]['id'] != $id) $f3->error(423, "O cluster já existe!");


            // Atualiza o imagem
            $values = array(
                'name'=>$name,
                'url'=>$url,
                'token'=>$token,
            );

            $this->ModelClusters->update($values, $filters=array('id'=>$id));

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

    public function delete($f3){
        try {
            $cluster_id = $_GET['cluster_id'];

            $this->ModelClusters->delete($filters=array('id'=>$cluster_id));

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

	public function list($f3) {
        try {
            $results = $this->ModelClusters->findAll();
                
            echo json_encode($results);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }		
	}

	public function view($f3) {
        try {
            $cluster_id = $_GET['cluster_id'];

            $cluster = $this->ModelClusters->find($columns=array(),$filters=array('id'=>$cluster_id ));
            if(!$cluster) $f3->error(406, "Cluster não encontrado!");

            $cluster = $cluster[0];
            $projects = $this->ModelProjects->findByClusterId($cluster_id);

            $cluster['projects'] = $projects;

            echo json_encode($cluster);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }

	} 

    public function insertProject($f3){
        try{
            $data = json_decode(file_get_contents('php://input'), true);	
            $cluster_id = $data['cluster_id'];
            $project_slug = $data['project_slug'];
    
            $project = $this->ModelProjects->find(
                $columns=array('id','slug',), 
                $filters=array('slug' => $project_slug)
            );
    
            if(!$project) $f3->error(406, "Projeto não encontrado!");
    
            $project = $project[0];
            
            if($this->ModelClusters->findByProjectId($project['id'], $cluster_id))
                $f3->error(423, "Projeto já está vinculado ao cluster!");
    
            
            $this->ModelClusters->insertProject($cluster_id, $project['id']);
            
            echo json_encode($project);
        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }

    } 

    public function deleteProject($f3){
        try{
            $cluster_id = $_GET['cluster_id'];
            $project_id = $_GET['project_id'];



            if(!$this->ModelClusters->findByProjectId($project_id, $cluster_id))
                $f3->error(423, "Projeto não está vinculado ao cluster!");

            
            $this->ModelClusters->deleteProject($cluster_id, $project_id);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }

    }
}
?>