<?php
class ControllerAdminImages extends Admin{
    public function __construct() {
        parent::__construct();
    }

    public function post($f3) {
		try {
            $data = json_decode(file_get_contents('php://input'), true);
            $registry = $data['registry'];
            $type = $data['type'];

            //Checa se imagem já existe
            $image = $this->ModelImages->find($columns=array('id'),$filters=array('registry'=>$registry));
            if($image) $f3->error(423, "A imagem já existe!");

            $this->ModelImages->insert(
                array('registry', 'public'), 
                array(
                    array(
                        $registry,
                        $type
                    )
                )
            );

		} catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

    public function put($f3){
        try {            
            $data = json_decode(file_get_contents('php://input'), true);
            $id = $data['id'];
            $registry = $data['registry'];
            $type = $data['type'];
            

            // Checa se imagem já existe
            $image = $this->ModelImages->find($columns=array('id'),$filters=array('registry'=>$registry));
            if($image && $image[0]['id'] != $id) $f3->error(423, "A imagem já existe!");



            // Atualiza o imagem
            $values = array(
                'registry'=>$registry,
                'public'=>$type,
            );

            $this->ModelImages->update($values, $filters=array('id'=>$id));

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

    public function delete($f3){
        try {
            $image_id = $_GET['image_id'];

            $this->ModelImages->delete($filters=array('id'=>$image_id));

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

	public function list($f3) {
        try {
            $results = $this->ModelImages->findWithNprojects();
                
            echo json_encode($results);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }		
	}

	public function view($f3) {
        try {
            $image_id = $_GET['image_id'];

            $image = $this->ModelImages->find($columns=array(),$filters=array('id'=>$image_id ));
            if(!$image) $f3->error(406, "Imagem não encontrada!");

            $image = $image[0];
            $projects = $this->ModelProjects->findByImageId($image_id);

            $image['type'] = ($image['public'] == '0') ? 'Privada' : 'Pública';
            $image['projects'] = $projects;

            echo json_encode($image);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }

	} 

    public function insertProject($f3){
        try{
            $data = json_decode(file_get_contents('php://input'), true);	
            $image_id = $data['image_id'];
            $project_slug = $data['project_slug'];
    
            $project = $this->ModelProjects->find(
                $columns=array('id','slug',), 
                $filters=array('slug' => $project_slug)
            );
    
            if(!$project) $f3->error(406, "Projeto não encontrado!");
    
            $project = $project[0];
            
            if($this->ModelImages->findIdByProjectId($image_id, $project['id']))
                $f3->error(423, "Projeto já está vinculado à imagem!");
    
            
            $this->ModelImages->insertProject($image_id, $project['id']);
            
            echo json_encode($project);
        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }

    } 

    public function deleteProject($f3){
        try{
            $image_id = $_GET['image_id'];
            $project_id = $_GET['project_id'];



            if(!$this->ModelImages->findIdByProjectId($project_id))
                $f3->error(423, "Projeto não está vinculado à imagem!");

            
            $this->ModelImages->deleteProject($image_id, $project_id);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }

    }
}
?>