<?php
class ControllerAdminProjects extends Admin{
    public function __construct() {
        parent::__construct();
    }

    public function post($f3) {
		try {
            $data = json_decode(file_get_contents('php://input'), true);	
            $name = $data['name'];
            $slug = $data['slug'];
            $nfs_ip = $data['nfs_ip'];
            $nfs_path = $data['nfs_path'];
            $status = $data['status'];

    
            $project = $this->ModelProjects->find($columns=array('id'),$filters=array('slug'=>$slug));
            if($project) $f3->error(423, "O slug já existe!");

        
            $columns=array(
                'name',
                'slug',
                'nfs_ip',
                'nfs_path',
                'status'
            );

            $values=array(
                array(
                    $name,
                    $slug,
                    $nfs_ip,
                    $nfs_path,
                    $status
                )
            );

            $this->ModelProjects->insert($columns, $values);

		} catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

    public function put($f3){
        try {
            $data = json_decode(file_get_contents('php://input'), true);
            $id = $data['id'];
            $name = $data['name'];
            $slug = $data['slug'];
            $nfs_ip = $data['nfs_ip'];
            $nfs_path = $data['nfs_path'];
            $status = $data['status'];
            

            
    
            $project = $this->ModelProjects->find($columns=array('id'),$filters=array('slug'=>$slug));
            if($project && $project[0]['id'] != $id) $f3->error(423, "O slug já existe!");


            $values = array(
                'name'=>$name,
                'slug'=>$slug,
                'nfs_ip'=>$nfs_ip,
                'nfs_path'=>$nfs_path,
                'status'=>$status
            );

            $this->ModelProjects->update($values, $filters=array('id'=>$id));

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

    public function delete($f3){
        try {
            $project_id = $_GET['project_id'];
            $jobs = $this->ModelJobs->find($columns=array(), $filters=array('project_id'=>$project_id));
            
            if($jobs) $f3->error(423, "Este projeto não pode ser removido!");

            $this->ModelProjects->delete($filters=array('id'=>$project_id));

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

	public function list($f3) {
        try {
            $results = $this->ModelProjects->findAll();
                
            echo json_encode($results);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }		
	}

	public function view($f3) {
        try {
            $project_id = $_GET['project_id'];


            $project = $this->ModelProjects->find($columns=array(),$filters=array('id'=>$project_id ));
            if(!$project) $f3->error(406, "Projeto não encontrado!");
            
            $project = $project[0];
            $participants = $this->ModelUsers->findByProjectId($project_id);

            $project['status'] = ($project['status'] == '0') ? 'Em Andamento' : 'Arquivado';
            $project['participants'] = $participants;

            echo json_encode($project);


        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }

	} 

    public function insertParticipant($f3){
        try{
            $data = json_decode(file_get_contents('php://input'), true);	
            $project_id = $data['project_id'];
            $e_mail = $data['e_mail'];
    
            $user = $this->ModelUsers->find(
                $columns=array('id','name','e_mail'), 
                $filters=array('e_mail' => $e_mail)
            );
    
            if(!$user) $f3->error(406, "Usuário não encontrado!");
    
            $user = $user[0];
            
            if($this->ModelProjects->findParticipantByUserId($user['id'], $project_id))
                $f3->error(423, "Usuário já faz parte do projeto!");
    
            
            $this->ModelProjects->insertParticipant($user['id'], $project_id);
            echo json_encode($user);
        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }

    }  
    
    public function deleteParticipant($f3){
        try{
            $project_id = $_GET['project_id'];
            $user_id = $_GET['user_id'];


            if(!$this->ModelProjects->findParticipantByUserId($user_id, $project_id))
                $f3->error(423, "Usuário não faz parte do projeto!");

            
            $this->ModelProjects->deleteParticipant($user_id, $project_id);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }

    }
}
?>