<?php
class ControllerAdminQueues extends Admin{
    public function __construct() {
        parent::__construct();
    }

    public function post($f3) {
		try {
            $data = json_decode(file_get_contents('php://input'), true);
            $name = $data['name'];
            $cluster = $data['cluster'];
            $n_nodes = $data['n_nodes'];

  
            if($this->ModelQueues->find($columns=array('id'),$filters=array('name'=>$name)))
                $f3->error(423, "A fila já existe!");


            $cluster = $this->ModelClusters->find($columns=array('id'),$filters=array('name'=>$cluster));
            if(!$cluster) $f3->error(406, "O cluster não existe!");

            $cluster = $cluster[0];

            $this->ModelQueues->insert(
                array('name', 'cluster_id', 'n_nodes'), 
                array(
                    array(
                        $name,
                        $cluster['id'],
                        $n_nodes
                    )
                )
            );

		} catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

    public function put($f3){
        try {
            $data = json_decode(file_get_contents('php://input'), true);
            $id = $data['id'];
            $name = $data['name'];
            $cluster = $data['cluster'];
            $n_nodes = $data['n_nodes'];
            
            $queue = $this->ModelQueues->find($columns=array('id'),$filters=array('name'=>$name));
            if($queue && $queue[0]['id'] != $id) $f3->error(423, "A fila já existe!");
            
   
            $cluster = $this->ModelClusters->find($columns=array('id'),$filters=array('name'=>$cluster));
            if(!$cluster) $f3->error(406, "O cluster não existe!");
            $cluster = $cluster[0];

  
            $values = array(
                'name'=>$name,
                'cluster_id'=>$cluster['id'],
                'n_nodes'=>$n_nodes
            );

            $this->ModelQueues->update($values, $filters=array('id'=>$id));

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

    public function delete($f3){
        try {
            $queue_id = $_GET['queue_id'];

            $this->ModelQueues->delete($filters=array('id'=>$queue_id));

        } catch (Exception $exception){
            $f3->error(500, "Erro interno!");
        }
    }

	public function list($f3) {
        try {
            $results = $this->ModelQueues->findAll();
                
            echo json_encode($results);

        } catch (Exception $exception){
            $f3->error(500, "Erro interno: " . $exception->getMessage());
        }		
	}


	public function view($f3) {
        try {
            $queue_id = $_GET['queue_id'];

            $queue = $this->ModelQueues->find($columns=array('name','n_nodes', 'cluster_id'), $filters=array('id'=>$queue_id));
            if(!$queue) $f3->error(406, "Fila não encontrada.");
            $queue = $queue[0];


            $cluster = $this->ModelClusters->find($columns=array('name'), $filters=array('id'=>$queue['cluster_id']));
            if(!$cluster) $f3->error(406, "Cluster não encontrada.");
            $cluster = $cluster[0];

            $jobs = $this->ModelJobs->findByQueue($queue['name']);
            
            $queue['jobs'] = $jobs;
            $queue['cluster_name'] = $cluster['name'];


            echo json_encode($queue);
 

        } catch (Exception $exception){
            $f3->error(500, "Erro interno: " . $exception->getMessage());
        }		

	}
}
?>