<?php
class ModelBase {
    protected $DB;
    protected $table_name;

    public function __construct($table_name) {
        $this->DB = new DB($_ENV["DB_SERVER"], $_ENV["DB_USER"], $_ENV["DB_PASSWORD"], $_ENV["DB_DB"]);
        $this->table_name = $table_name;
    }

    public function find($columns=array(), $filters=array(), $order=Null){
        //Monta SQL.
        $sql = "";

        //SELECT
        $sql = "$sql SELECT";

        //Se foi expecificado as colunas.
        if ($columns){
            //Monta SELECT com as colunas expecificadas.
            for ($i = 0; $i < count($columns); $i++) {
                if($i != count($columns) - 1){
                    $sql = "$sql $columns[$i],";
                }else{
                    $sql = "$sql $columns[$i]";
                }
            }
        //Se não
        } else{
            //Retorna todas as colunas.
            $sql = "$sql *";
        }

        //FROM
        $sql = "$sql FROM $this->table_name";


        //WHERE
        if ($filters){
            $sql = "$sql WHERE";
            $keys = array_keys($filters);

            for ($i = 0; $i < count($keys); $i++) {
                $key = $keys[$i];
                if($i != count($keys) - 1){
                    $sql = "$sql $key = '$filters[$key]' AND";
                }else{
                    $sql = "$sql $key = '$filters[$key]'";
                }
            }
        }

        //ORDER
        if ($order){
            $sql = "$sql ORDER BY $order";
        }

        #Busca no DB e retorna resultados.
        $results = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($results)) {
            array_push($list, $row);
        }

        return $list;
    }

    public function delete($filters){
        //Monta SQL.
        $sql = "";

        //DELETE
        $sql = "$sql DELETE";

        //FROM
        $sql = "$sql FROM $this->table_name";

        //WHERE
        $sql = "$sql WHERE";
        $keys = array_keys($filters);

        for ($i = 0; $i < count($keys); $i++) {
            $key = $keys[$i];
            if($i != count($keys) - 1){
                $sql = "$sql $key = '$filters[$key]' AND";
            }else{
                $sql = "$sql $key = '$filters[$key]'";
            }
        }

        $this->DB->updateN(array($sql));
    }

    public function update($values, $filters){
        //Monta SQL.
        $sql = "";

        //UPDATE
        $sql = "$sql UPDATE $this->table_name";

        //SET
        $sql = "$sql SET";
        $columns = array_keys($values);

        for ($i = 0; $i < count($columns); $i++) {
            $column = $columns[$i];
            if($i != count($columns) - 1){
                $sql = "$sql $column = '$values[$column]',";
            }else{
                $sql = "$sql $column = '$values[$column]'";
            }
        }

        //WHERE
        $sql = "$sql WHERE";
        $keys = array_keys($filters);

        for ($i = 0; $i < count($keys); $i++) {
            $key = $keys[$i];
            if($i != count($keys) - 1){
                $sql = "$sql $key = '$filters[$key]' AND";
            }else{
                $sql = "$sql $key = '$filters[$key]'";
            }
        }

        $this->DB->updateN(array($sql));


    }

    public function insert($columns, $values){
        #Monta SQL.
        $sql = "";

        //INSERT INTO
        $sql = "$sql INSERT INTO $this->table_name (";

        for ($i = 0; $i < count($columns); $i++) {
            if($i != count($columns) - 1){
                $sql = "$sql $columns[$i],";
            }else{
                $sql = "$sql $columns[$i])";
            }
        }

        

        //VALUES
        $sql = "$sql VALUES";

        for ($i = 0; $i < count($values); $i++) {
            $sql = "$sql (";
            for ($j = 0; $j < count($values[$i]); $j++) {
                $value = $values[$i][$j];
                if($j != count($values[$i]) - 1){
                    $sql = "$sql '$value',";
                }else{
                    $sql = "$sql '$value')";
                }
            }

            if($i != count($values) - 1) $sql = "$sql,";
        }

        #Inseri no DB e retorna id.
        $result = $this->DB->insert(strval($sql));
        return $result;
    }
}
?>