<?php

class ModelImages extends ModelBase{

    public function findAll($header=array()){
        $col = '';
        if (count($header) > 0) {
            foreach ($header as $value) {
                $col = $col . "$value,";
            }
            $col = substr($col, 0, -1);
        }else {
            $col = '*';
        }

        $sql = "SELECT $col
                FROM images;";

        $result = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;
    }
    
    public function findByProjectId($project_id) {
        $sql = "SELECT registry
                FROM images
                WHERE 
                id in (SELECT image_id FROM images_permissions WHERE project_id = $project_id) 
                or public = '1'
                ORDER BY registry;";

        $results = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($results)) {
            array_push($list, $row['registry']);
        }

        return $list;
    }

    public function findWithNprojects(){
        $sql = "SELECT images.id as id, 
                        images.registry as registry,
                        images.public,
                        CASE images.public 
                            WHEN '1' THEN 'Pública' 
                            WHEN '0' THEN 'Privada'  
                        END AS type,
                        count(images_permissions.project_id) as n_projects
                FROM `images` 
                LEFT JOIN images_permissions on images_permissions.image_id = images.id
                GROUP BY images.id, images.registry, images.public
                ORDER BY images.registry;";

        $result = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;
    }


    public function findIdByProjectId($image_id, $project_id) {
        $sql = "SELECT image_id 
                FROM images_permissions
                WHERE project_id = $project_id and image_id = $image_id";


        $result = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;
    }

    public function insertProject($image_id, $project_id){
        $sql = "INSERT INTO images_permissions (image_id, project_id) 
        VALUES ($image_id,$project_id);";


        $result = $this->DB->insert(strval($sql));
        return $result;
    }

    public function deleteProject($image_id, $project_id){
        $sql = "DELETE FROM images_permissions
                WHERE image_id = $image_id and project_id = $project_id;";

                
        $this->DB->updateN(array($sql));
    }

    
}
?>