<?php

class ModelProjects extends ModelBase{
    public function findByUserId($user_id) {
        $sql = "SELECT id, slug
                FROM projects
                WHERE id in (SELECT project_id 
                             FROM projects_permissions 
                             WHERE user_id = $user_id)
                ORDER BY slug;";

        $result = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;
    }

    public function findAll(){
        $sql = "SELECT projects.id, 
                       projects.slug, 
                       projects.name, 
                       projects.nfs_ip, 
                       projects.nfs_path, 
                       CASE projects.status
                       WHEN 0 THEN 'Em Andamento'
                       WHEN 1 THEN 'Arquivado'
                       END AS status,
                       count(projects_permissions.user_id) as users
        FROM projects
        LEFT join projects_permissions  on projects.id = projects_permissions.project_id
        GROUP BY projects.id
        ORDER BY projects.slug;";

        $result = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;
        
    }

    public function findParticipantByUserId($user_id, $project_id){
        $sql = "SELECT * FROM projects_permissions
                WHERE user_id = $user_id and project_id = $project_id;";
        
        $result = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;
    }

    public function insertParticipant($user_id, $project_id){
        $sql = "INSERT INTO projects_permissions (user_id, project_id) 
                VALUES ($user_id,$project_id);";

        
        $result = $this->DB->insert(strval($sql));
        return $result;
    }

    public function deleteParticipant($user_id, $project_id){
        $sql = "DELETE FROM projects_permissions
                WHERE user_id = $user_id and project_id = $project_id;";

                
        $this->DB->updateN(array($sql));
    }

    public function findByImageId($image_id){
        $sql = "SELECT projects.id, projects.slug
                FROM projects
                LEFT JOIN images_permissions ON images_permissions.project_id = projects.id
                WHERE images_permissions.image_id = $image_id";
        
        $result = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;

    }

    public function findByClusterId($cluster_id){
        $sql = "SELECT projects.id, projects.slug
                FROM projects
                LEFT JOIN clusters_permissions ON clusters_permissions.project_id = projects.id
                WHERE clusters_permissions.cluster_id = $cluster_id";
        
        $result = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;

    }


}
?>