<?php

class ModelQueues extends ModelBase{
    
    public function findByUserIdAndQueueId($user_id, $queue_id){
        #Monta sql.
        $sql = "SELECT queues.name FROM queues 
                LEFT JOIN clusters on clusters.id = queues.cluster_id
                LEFT JOIN clusters_permissions on clusters_permissions.cluster_id = clusters.id
                LEFT JOIN projects on projects.id =  clusters_permissions.project_id
                LEFT JOIN projects_permissions on projects_permissions.project_id = projects.id
                LEFT JOIN users on users.id = projects_permissions.user_id
                WHERE users.id = $user_id and queues.id = $queue_id;" ;

        #Faz busca no DB.
        $result = $this->DB->select(strval($sql));
        return $result->fetch_assoc();
    }

    public function findByProjectId($project_id) {
        #Monta sql.
        $sql = "SELECT name
                FROM queues
                WHERE cluster_id in (SELECT cluster_id 
                             FROM clusters_permissions
                             WHERE project_id  = $project_id)
                ORDER BY name;";

        #Busca no DB e retorna resultados.
        $results = $this->DB->select(strval($sql));

        $list = array();
        while ($row = mysqli_fetch_assoc($results)) {
            array_push($list, $row['name']);
        }

        return $list;
    }
    
    public function findAll(){
        $sql = "SELECT queues.id,
                       queues.name as name,
                       queues.n_nodes,
                       clusters.name as cluster,
                       COUNT(jobs.id) as n_jobs
                FROM queues
                LEFT JOIN clusters on queues.cluster_id = clusters.id
                LEFT JOIN (SELECT jobs.id, jobs.queue FROM jobs
                            LEFT JOIN commands on jobs.id = commands.job_id
                            WHERE commands.state = 0 or commands.state = 1
                            GROUP BY jobs.id
                        ) as jobs on queues.name = jobs.queue
                GROUP BY queues.id, queues.name, queues.n_nodes, clusters.name
                ORDER BY queues.name;";


        #Faz busca no DB.
        $result = $this->DB->select(strval($sql));

        #Retorna resultados.
        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;

    }

    public function findByUserId($user_id){
        $sql = "SELECT queues.id,
                        queues.name as name,
                        queues.n_nodes,
                        clusters.name as cluster,
                        COUNT(jobs.id) as n_jobs
                FROM queues
                LEFT JOIN clusters on queues.cluster_id = clusters.id
                LEFT JOIN (SELECT jobs.id, jobs.queue FROM jobs
                            LEFT JOIN commands on jobs.id = commands.job_id
                            WHERE commands.state = 0 or commands.state = 1
                            GROUP BY jobs.id
                        ) as jobs on queues.name = jobs.queue
                LEFT JOIN clusters_permissions on clusters_permissions.cluster_id = clusters.id
                LEFT JOIN projects_permissions on projects_permissions.project_id = clusters_permissions.project_id
                WHERE projects_permissions.user_id = $user_id
                GROUP BY queues.id, queues.name, queues.n_nodes, clusters.name
                ORDER BY queues.name;";


        #Faz busca no DB.
        $result = $this->DB->select(strval($sql));

        #Retorna resultados.
        $list = array();
        while ($row = mysqli_fetch_assoc($result)) {
            array_push($list, $row);
        }

        return $list;
        
    }

}
?>