<?php
class utilities {
    public static function updateStates(){
        $ModelJobs = new ModelJobs('jobs');
        $ModelCommands = new ModelCommands('commands');
        $SlurmAPI = new SlurmAPI();

        $jobs = $ModelJobs->findAllByState();

        $clusters = array();
        $SlurmIdsByCluster = array();
        $jobsByCluster = array();
        foreach ($jobs as $job) {
            $cluster = $job['cluster_name'];

            if (!array_key_exists($cluster, $clusters)) {
                $clusters[$cluster] = array(
                    'url' => $job['cluster_url'],
                    'token' => $job['cluster_token']
                );

                $SlurmIdsByCluster[$cluster] = array();
                $jobsByCluster[$cluster] = array();
            }

            array_push($SlurmIdsByCluster[$cluster], $job['id_slurm']);
            array_push($jobsByCluster[$cluster], array(
                                            'id_slurm' => $job['id_slurm'],
                                            'id_job' => $job['job_id']
                                            ));
        }


        foreach ($clusters as $cluster_name => $cluster_params) {
            $results = $SlurmAPI->getJobs($cluster_params['url'], 
                                            $cluster_params['token'],
                                            array(
                                                'ids' => $SlurmIdsByCluster[$cluster_name]
                                            ));
            
            
            $ModelCommands->updateN($jobsByCluster[$cluster_name], $results);

        }
            
    }


}
?>