<?php

class DB {
  protected $servername;
  protected $username;
  protected $password;
  protected $dbname;
  protected $conn;

  public function __construct($servername, $username, $password, $slurm_acct_db) {
    $this->servername = $servername;
    $this->username = $username;
    $this->password = $password;
    $this->dbname = $slurm_acct_db;

  }

  private function connect() {
    $this->conn = new mysqli($this->servername, $this->username, $this->password, $this->dbname);
    if ($this->conn->connect_error) {
      die("Connection failed: " . $this->conn->connect_error);
    }
  }

  private function disconnect(){
    $this->conn->close();
  }

  public function select($sql) {
    $this->connect();
    $result = $this->conn->query($sql);
    $this->disconnect();
    if ($result) {
      return $result;
    } else {
      die("Query failed: " . $this->conn->error);
    }
  }

  public function insert($sql){
    $this->connect();
    $result = $this->conn->query($sql);
    $id = mysqli_insert_id($this->conn);
    $this->disconnect();
    if ($result) {
      return $id;
    } else {
      die("Query failed: " . $this->conn->error);
    }

  }

  public function updateN($sql_list) {
    $this->connect();
    $result = Null;
    foreach ($sql_list as $sql){
      $result = $this->conn->query($sql);
      if (!$result) {
        $this->disconnect();
        die("Query failed: " . $this->conn->error);
    }

    }

    $this->disconnect();
    return $result;
  }


}
?>