<?php
require 'vendor/autoload.php';
require 'config/db.php';
require 'app/models/base.php';
require 'app/models/jobs.php';
require 'app/models/commands.php';
require 'app/APIs/slurm.php';

while (TRUE) {
    try{

        $ModelJobs = new ModelJobs('jobs');
        $ModelCommands = new ModelCommands('commands');
        $SlurmAPI = new SlurmAPI();


        $jobs = $ModelJobs->findAllByState();



        $clusters = array();
        $SlurmIdsByCluster = array();
        $jobsByCluster = array();

        foreach ($jobs as $job) {
            $cluster = $job['cluster_name'];



            if (!array_key_exists($cluster, $clusters)) {
                $clusters[$cluster] = array(
                    'url' => $job['cluster_url'],
                    'token' => $job['cluster_token']
                );

                $SlurmIdsByCluster[$cluster] = array();
                $jobsByCluster[$cluster] = array();
            }

            array_push($SlurmIdsByCluster[$cluster], $job['id_slurm']);
            array_push($jobsByCluster[$cluster], array(
                                            'id_slurm' => $job['id_slurm'],
                                            'id_job' => $job['job_id']
                                            ));
        }



        foreach ($clusters as $cluster_name => $cluster_params) {
            if($cluster_name != '7x_24c_64G' &&  $cluster_name !=  '1x_20c_128G_3080' && $cluster_name  != '10x_12c_32G'){
                $results = $SlurmAPI->getJobs($cluster_params['url'], 
                $cluster_params['token'],
                array(
                    'ids' => $SlurmIdsByCluster[$cluster_name]
                ));


                if($results) $ModelCommands->updateN($jobsByCluster[$cluster_name], $results);
            }
            


        }
    } catch(Exception $exception){
        echo $exception;
        continue;
    }

    sleep(1);
}
?>
